"Casualties: Together" Co-Op Mod by Krokosha666 for game "Casualties: Unknown"
Official link: https://github.com/Krokosha666/cas-unk-krokosha-multiplayer-coop
buymeacoffee: https://buymeacoffee.com/krokosha666


KNOWN ISSUES:
 - Catastrophic desync for clients 
 - Extreme lag for clients.
 - Extreme lag with larger time scale.
 - Gun jamming might desync
 - Console commands are not synced. (but there is admin mode to run commands on server side)
 

	

--- 3.1.0 --- 04.06.2026 --- Sloppy 7.0 port --- 
- Additions
    Patched phantom screen shake effect for:
    - Spike stabber
    - Jump pad
    - Coil trap
    - Bear trap
    - Grappling hook
    Added "Toggle to talk" mode to voicechat.
    Added rule "AlwaysAllowCarry" to allow carrying conscious players. default "false"
- Changes
    Ported to 7.0.1 game version.
    Adjusted some CPR values.
- Fixes
    Fixed Auto-updater not applying the update.
    Added missing text in CPR minigame.
    Fixed bug report send not working if you have unicode username in steam.



 --- 3.0.0 --- 01.05.2026 --- Steam Update --- 
Ported to the game version v6.1
Replaced the network library "Unity Netcode for GameObjects" to "LiteNetLib" in hopes for better performance.
Added button to deactivate multiplayer mod to play singleplayer without copying the game.
 - Can be also done with cmd arg "--ksmulti-disable"
Steam Networking Support added !!!!!!
 - Added steam lobbies browser.
 - Host steam lobbies n shi, u know steam works burh
Major internal rewrites.
 - Major optimizations. ( hopefully)
 - - Improved performance of Climbables sync.
 - - Improved performance of buildings and items player distance calculations.
 - - And much more crazy science shi
 - Fixed stuff occasionally duplicating mostly in other players inventories.
Complete GUI overhaul.
 - Everything has to be translatable now.
 - Tried to replace the default unity look with the game ui textures.
 - Made proper connection menu.
 - Made proper settings menu.
 - Made proper credits menu.
Added Bug Report form.
Added Auto-Updater button.
Localization json files now have more priority over hardcoded text, so its possible to override default text now.
Chat shows player colors.
Location ping (by MMB) now fades out.
Spectator can click on players to spectate them.
Fixed console banned commands bypass backdoor through repeat and bind commands.
Fixed item decay depending only on host movement instead of whoever's carrying it.
Fixed fullbright not working in spectator mode.
Fixed not being able to interact with limbs in woundview that the local player has amputated.
Fixed infinite earthquake for clients when host character is sleeping.
Fixed "Feed" action not working with wearables.
Fixed minigame hands of other players not being removed after exiting.
Fixed Dislocation Minigame often leaving dislocation at 1%.
Patched some global sounds to sound more as expected.
Patched WoundView fullscreen miserable happiness indicator, to show only for local body.
Somewhat synced blueprints?? i guess?
Increased radius of immediate chunk sync.
"Feed" action name changes to "Use Item" and "Dress" for specific items.
Everything in tutorial is synced the same as in main game. (No more forced desync in there)
Command setlimbfield also accepts "all" to set a value to all limbs.
Optimized the way visible chunks of players are calculated.
Respawn with RespawnKeepSkills keeps mindwipe.
Renamed most rules to be sorter:
Renamed all FriendlyFire rules to PVP.
 - "AllowJoinWhileInGame" to "LateJoinAllowed"
 - "LayerFinishActivateRadlineForStragglersPlayerPercent" to "StragglerRadlinePlayerPercent"
 - "PlayerScatterPunishMinPlayerPercent" to "PlayerScatterMinGroupSize"
 - and more...
Added rule "LateJoinSpectate". Late joined players will instantly die and put into spectator mode.
Added Teams:
 - It's a really barebones system.
 - Teams are determined by colors.
 - Disabled by default with rule "Teams"
Added CPR.
 - CPR is unavailable if you're too weak or the pacient is fine.
 - You have to do perfect 100 bpm for it to work. 
 - It's also added to AED Minigame.
Added Keybind for "Push" action. Default "F"
Added Keybind for "Carry" action. Default "O"
Added Keybind for "Piggyback" action. Default "P"
Press Shift to reveal player locations. (instead of just the pause menu)
Added piggyback stacking, towering is now possible.
 - Replaced rule "AllowPiggyback" to "PiggybackMaxStack"
Added IPv6 support.
Added server name field.
Allowed non-ascii characters in password.
theres more changes, i forgor to write all



 --- 2.1.2 --- 12.03.2026 --- Save patch --- 
Fixed anti player scatter unfairly engaging while late-joining.
Fixed some piggyback desyncs for host.
Fixed crafting in tutorial world.
Fixed that harmless FreshItemDrop.OnDestroy error.
Sleeping - Energy timer syncs up with nearby players.
Patched save system, now it saves other players.
Patched time scale buttons to disappear when rule disables it.
Removed logging of Host IP. (release builds only)
Removed logging of chat. (verbose mode and chatspy re-enables it)
Added command "mpverbose" -> originally "krok verbose"
Added command "syncinfo" -> originally "krok syncinfo"
Added command "syncreset" -> originally "krok objreset"
Added command "maxplayers" -> originally "krok maxplayers"
Removed command "krok" cuz all its functionality is now replaced with new commands
Added command "clearinventory"



 --- 2.1.1 --- 06.03.2026 --- Inventory and containers fixes fixing fixed patches --- 
"Push" player interaction now depends on your strength skill.
Improved worldgen parameters sync.
Improved skills sync.
Improved crafting sync.
Improved inventory sync.
Upgraded some UI.
Fixed late-joined client not recieving layer modifier.
Fixed client crafted items dropping on the ground when inventory was full.
Fixed player death not applying mood debuff to witnesses.
Fixed landmines not being triggered by items when far from players.
Fixed splints and tourniquets not taking off.
Fixed liquid crafting not merging it into exising bottles.
Fixed bug that breaks the entire game if its launched for the first time.
Fixed mp3player memory leak after music stopped.
Fixed chat unfocusing itself.
Patched breaking corpse to apply mood debuff to clients.
Increased PlayerScatterPunishDistance to 60.
Slowed down straggler radline.
Removed Position indicator at top left.
Adjusted all console commands execution permissions.
 - Added command "adminpriv-password" - if ur too lazy manually assigning admins every time, tell em the password
Removed the "mp-" prefixes from all commands cuz they have it in the description.
Added command "vcbackgroundmusicattenuation" - change how much voicechat attenuates background music.
Added command "mp3listenervolume" - separately mute mp3players instead of the entire voice chat
Added command "vclistenervolume"
Added command "vclistenervolume-individual"
Added command "printposition"
Added command "disconnect"
Added rule "RespawnKeepSkills"
Added rule "XPGainMultiplier"
Added rule "FriendlyFireDamageMultiplier"
Improved Spectator mode:
 - Added freecam mode.
 - - Rule "AllowSpectatorFreecam"
 - Spectator UI is hidden when viewing health panel.
 - Option to only spectate living players.
 - Spectator can see moodles of players.
 - Fixed infinite underwater ambience if died in water.
New Co-op mechanic:
 - Stay close to happier players to slow down mood loss. 



 --- 2.0.1 --- 26.02.2026 --- Dedicated server Hotfix --- 
Fixed dedicated servers not generating any traps.
Increased nearby item sync batch size.
Improved item condition sync.



 --- 2.0.0 --- 26.02.2026 --- Cooperation Enforcement Update --- 
Ported to the game version v5.1
Updated BepInEx version to 5.4.23.5
Fixed dedicated server sometimes spawning players in the void.
Fixed players spawning in wrong place.
Fixed landmines not exploding when too far from host.
Fixed "Push" player interaction, now it applies velocity as intended.
Fixed not being able to carry unconscious players.
Fixed camera jumping when somebody spawns.
Fixed infections always being shown on other players when you're dead.
Fixed body workout cancel global. 
Fixed broken cooldown for Elder Thornback bite.
 - and all other spiders
Fixed vomitting not applying debuffs on dedicated server.
Added text chat distortion preview. (automatically shown while typing, if distortion is present)
Added that console player name parser also accepts client id. (like "id:1" or "id:123")
Added more default player colors.
Patched phantom headhit sound.
Patched phantom mindwipe effect.
Patched phantom depression ambience.
Patched trader death to properly apply mood debuff to everyone around.
Respawning dead players now resets skills.
Significantly improved synchronization performance.
Adjusted object sync to properly check for container contents and player inventories.
Improved piggybacking, (visually: ragdoll is not frozen, functionally: added ability to aim guns - piggyback turret is now a thing!).
Compressed tile chunk and fluid chunk packets.
Compressed object sync packets.
Smoother player interaction menu.
Client now actually waits for server to generate world.
Improved dislocation minigame sync.
"Inspect Wounds" player interaction can also be done from a custom keybind ( Default "R" )
Proximity text chat now has text clarity falloff. (as if you can't hear people very far away)
Removed dedicated server automatic spectator switching.
Removed rule "ForNextLayerAllMustReachEnd" 
Removed Lockpicking minigame cooperation sync. (cuz nah i aint syncing lockpick item)
Replaced rule "DisableSleep" to "EnableSleep"
Replaced rule "DisableTimeManipulation" to "EnableTimeManipulation" (btw its still broken, dont actually enable it)
Renamed rule "SpeechImpairedTextChat" to "SpeechImpairedChat"  because it also affects voice chat.
Renamed "CommunicateWithTheDead" to "CommunicateWithTheDeadTextchat"
New game rule "HearingLossChat" default "true" - distorts chat according to your hearing loss, brain damage, mindwipe, ...
Added rule "MetabolismMultiplier" to slow down hunger and thirst
Added rule "PlayerScatterPunishDistance" default "30" (in in-game "meters" (meter * 0.3 = block) ) // to kill those who abandon their friends,  set it to 60000 to disable
Added rule "PlayerScatterPunishMinPlayerPercent" default "51%" // 0 = disable, 1 = duo, 50 = half, 100 = everyone must stay completely together // how much players have to be around one player before scatter punishment activates // number below 50 allows players to divide into several groups if the player count is high enough
Added rule "LayerFinishConditionPlayerPercent" default "60%" // 0 = one player, 50 = half, 100 = everyone must be at the end, 101 = disable
Added rule "LayerFinishActivateRadlineForStragglersPlayerPercent" // 0 = one player, 50 = half, 100 = disabled // activates radline right above the last straggler when specified percent of players reach the end
Added rule "RespawnKeepInventory" it keeps whatever stayed on ur dead body and wasnt stolen or decomposed.
Added rule "SavePlayerStateOnDisconnect" it saves health and skills on rejoin. (but only on same level, these saves are reset on layer transitions)
Added rule "DServerMinPlrsToStart" default "2"
Added rule "DServerToMainMenuWhenAllDied" 
Added rule "DServerToMainMenuWhenAllLeft" 
Mindwipe now completely distorts chat for true mindless experience.
 - Rule "MindwipeDisablesChat" = true;  // REQUIRES  SpeechImpairedChat and HearingLossChat
Removed CMD arg "--ksmulti-min-plr-count"
Witnessing a player death affects mood same as corpse.
Witnessing a player self-harm reduces mood. (less if player is desensitized)
 - Rule "SelfharmWitnessMoodDebuff"
Added Voice Chat.
 - Select any microphone.
 - Adjust volume of your microphone.
 - Adjust voicechat listening volume.
 - New rule "VoicechatEnabled" 
 - New rule "CommunicateWithTheDeadVoicechat" 
 - New rule "VoicechatQuality" // min 0 - max 4
Added player status icons.
 - Typing in chat.
 - Opening a console.
 - Unfocusing window.
 - Healing other players.
Added commands:
 - talker-on-cursor-say [string]
 - earthquake [now/disable/enable]
 - setpref [string] [value]   - set run settings (like loot rarity, trap amount, and others)
 - say [string]  - send a chat message
 - chatbox-pos [float] [float] [float] [float] [float]  - set location and size of chat box
 - rule [string] [value] - same as "krok rule" but now with autocomplete
 - setplrname [player] [string]
 - setplrcolor [player] [color]
 - connect - Client Connect but through a console comand
 - starthost - Host but through a console comand
 - startserver - Dedicated server start but through a console comand
 - adminpriv - Allow clients to run commands on server and view its log
 - admin - Client: enter the server console if u have the privilege
 - theres more i forgor
 - hidehud
 - godmode
 - zoom [number]
 - settile [id] [optional x] [optional y]
 - setfluid [id] [optional x] [optional y]
Changed Version 5 features:
 - command "heal" accepts player name -> "heal [optional player]"
 - command "setlimbfield" accepts player name -> "setlimbfield [limb] [field] [value] [optional player]"
 - command "setbodyfield" accepts player name -> "setbodyfield [field] [value] [optional player]"
 - command "addxp" accepts player name
 - command "resetskills" accepts player name
 - command "kill" accepts player name
 - command "alert" from server is shown globally
 - command "tp" accepts player name -> "tp [position] [optional player]"
 - Amputation minigame sorta remembers amputation state on the specific limb if restarted. (amputation progress state is relative to current muscle health)
 - - Can cannibalize living players with the new rule "CanAmputateHealthyPlayers"
 - mp3player item is a separate audiosource, it doesn't replace background music.
 - - Clients can only choose music from the Server "custommusic" folder.
 - - Music is just streamed, it's not being downloaded.
Added CMD arg "--ksmulti-runcommand" // run a in-game console command in main menu after the game and mp starts // example: "--ksmulti-runcommand setpref_loot_0;log_hello_world;log_another_message_idk"
Added CMD arg "--ksmulti-setpass" // to set a password

Special thanks for participation goes to:
 - Gary the cat - @garythecat  - Leading and hosting the playtests
 - notamoron - @nam_7876_25172  - playtester
 - avr - @avr_crtscc  - playtester
 - ItsVoidSK - @itsvoidskilled  - playtester
 - {Pixel} - @canned_pixels  - playtester
 - Ìðàê 2.0 - @mrakmm  - playtester
 - Shade - @waz2280  - playtester
 - Dictator - @snow_5107  - playtester



 --- 5.4.1.12 --- 04.02.2026 --- Piggyback update --- 
Added Piggyback/Carrying other players.
 - You need enough strength to carry other player.
 - Carrying very heavy load will make you unable to move.
Added 3 buttons to player interaction menu
 - "Piggyback" - ride the other player
 - "Carry" - grab and carry the other player
 - "Push" - pull a prank and push em off a cliff  ( requires rule "AllowPush" default "true" )
Fixed host ip being locked to the ip being inputted (127.0.0.1 works again as expected).
Rule changer gui is unlocked ingame if sv_cheats are on.
Removed the vignette in spectator.
Added missing "--ksmulti-startserver" cmd argument.
Improved lockpicking minigame sync.
Added rule "FriendlyFireCombatDismember"
Added rule "FriendlyFireAttackerMoodDebuff"
Updated BepInEx version to 5.4.23.4



 --- 5.4.1.11 --- 24.12.2025 --- Object sync improvement --- 
Increased object load radius.
Fixed chat not working after playing and going back to main menu.
Fixed structure backgrounds syncing extremely lazily.
Hopefully fixed player inventories getting stuck in desync purgatory after a layer transition.
Hopefully fixed weird issue where caveticks broke all ur bones.



 --- 5.4.1.10 --- 23.12.2025 --- Major synchronization improvements and also Cannibalism update --- 
Unchipped hides nametags.
 - New game rule "DisableNametagsIfUnchipped"
Colored talker. (Player speech text above their head is now their player color)
Fixed broken "krok maxplayers [number]" command.
@c macro now picks the nearest character to your cursor.
Added a rule to disable chat history.
 - New game rule "EnableChatbox"
 - New game rule "OnlyProximityChat"
 - New game rule "OnlyProximityChatIfUnchipped"
 - - Unchipped players messages are only visible if they are on your screen.
 - - If you are chipped, you can't see unchipped players messages in the chat history. (unless they are visible on your screen)
Added Cannibalism.
 - Attacking a dead body is allowed even when FriendlyFire is off.
 - Attacking or shooting a very damaged body part has a chance to amputate.
 - Every second amputated limb drops yellow flesh.
 - When player is dead you can dismember their vital body parts like head,
 - A vital body part drops internal organs.
Ensured that the syringe minigame actually fucking injects the stuff finally.
Location ping pointing arrow disappears if too close.
Added mod version validation during connection.
Added an error message for when the mod fails to initialize.
Ping and network mode always shown. (its for me to review video footage more accurately)
Improved unregistered items handling.
Stricter IP:PORT format check.
Added support to connect to a domain instead of an ip.
Added dedicated server support. See "FOR-NERDS.txt" for hosting info.
Fixed attacking an animal (spiders) not doing the extended cooldown. 
Fixed frozen items and buildings outside of hosts view.
Added game rules configuration menu.
Synced radioactive objects to actually irradiate clients.
Fixed phantom irradiated visual effect.
Fixed opiate state not being reset on client. 
Fixed being able to open crafting menu while spectating.
"krok give" command now supports multiple item ids
Rewrote world chunks sync. Now it efficiently sends relevant chunks to clients, making the inconsistent Worldgen much less noticable.
Synced cave tick swarms.
Improved sandvine sync.
Dead players bodies will stop creating bleed particles after they ran out of blood.
Made stalagtite/skullcrusher/crate hits client-authoritative.
Added a player locator to the brightness menu. It shows direction and distance to all players.
Command "krok tp [player name] @c" now teleports to cursor location.
Fluid simulation now works outside of hosts view.
Changed main menu a bit.
Added "Open Woundview" button to the spectator mode. To view health of spectated player.
Added "Stop spectating" button to the spectator mode.
Added "spectate" console cheat command, to spectate even when you're alive.
Patched combat music trigger distance.
Unlocked noclip command. (it was officially added in pretest 5)
Unlocked fullbright command. (it was officially added in pretest 5)
Slightly nerfed gun friendly fire damage. (idk why but whatever)
When you sleep it shows list of players that are not sleeping.



 --- 5.4.1.9 --- 16.11.2025 --- Public release Hotfix --- 
Added disconnection chat messages.
Fixed bug that caused all players clear inventory when continuing to next layer.
Host now requires a name. To fix potentially broken chat and allat.



 --- 5.4.1.8 --- 16.11.2025 --- Public release --- 
Release









